<?php

namespace HeimrichHannot\MultiColumnEditor;

use HeimrichHannot\Request\Request;

class Hooks extends \Controller
{
    public function executePostActionsHook($strAction, \DataContainer $objDc)
    {
        if ($strAction == MultiColumnEditor::ACTION_ADD_ROW || $strAction == MultiColumnEditor::ACTION_DELETE_ROW ||
            $strAction == MultiColumnEditor::ACTION_SORT_ROWS
        ) {

            $objDc->field = Request::getPost('field');
            $objDc->table = Request::getPost('table');

            if (!$objDc->field || !$objDc->table) {
                header('HTTP/1.1 400 Bad Request');
                die('Bad Request');
            }

            die(MultiColumnEditor::generateEditorForm('multi_column_editor', $objDc->table, $objDc->field, $objDc->value, $objDc));
        }
    }

    public function loadDataContainerHook($strTable)
    {
        if (!Request::getPost('name'))
        {
            return;
        }

        $arrParts = explode('_', Request::getPost('name'));

        if (empty($arrParts) || $GLOBALS['TL_DCA'][$strTable]['fields'][$arrParts[0]]['inputType'] !== 'multiColumnEditor')
        {
            return;
        }

        // support for jumpTo fields -> bypass check in \Contao\Ajax -> comment "The field does not exist" line 282
        if ((Request::getPost('action') != 'reloadPagetree' && Request::getPost('action') != 'reloadFiletree') || $strTable === 'fieldpalette') {
            return;
        }

        $GLOBALS['TL_DCA'][$strTable]['fields'][Request::getPost('name')] = true;
    }
}